<?php
/*

GENERIC bad-behavior code ported to Joomla! by Tudor (webmaster[at]teachmejoomla.net)

Bad Behavior - detects and blocks unwanted Web accesses
Copyright (C) 2005-2006 Michael Hampton

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

As a special exemption, you may link this program with any of the
programs listed below, regardless of the license terms of those
programs, and distribute the resulting program, without including the
source code for such programs: ExpressionEngine

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

Please report any problems to badbots AT ioerror DOT us
*/

###############################################################################
###############################################################################

define('BB2_CWD', dirname(__FILE__));
//error_reporting(E_ERROR);
// Settings you can adjust for Bad Behavior.
// Most of these are unused in non-database mode.

global $bb2_settings;

 /*
 $bb2_settings = array(
	'log_table' => '#__bb2_log',
	'display_stats' => false,
	'strict' => false,
	'verbose' => true,
	'installed' => false
);
*/

// Bad Behavior callback functions.

// Return current time in the format preferred by your database.
function bb2_db_date() {
	return gmdate('Y-m-d H:i:s');	// Example is MySQL format
}

// Return affected rows from most recent query.
function bb2_db_affected_rows() {

	global $database;

	return $database->getAffectedRows();
}

// Escape a string for database usage
function bb2_db_escape($string) {
	global $database;

	// return mysql_real_escape_string($string);
	return $database->getEscaped($string);	// No-op when database not in use.
}

// Return the number of rows in a particular query.
function bb2_db_num_rows($result) {
	if ($result !== FALSE)
		return count($result);
	return 0;
}

// Run a query and return the results, if any.
// Should return FALSE if an error occurred.
// Bad Behavior will use the return value here in other callbacks.
function bb2_db_query($query) {
	global $database;
	
	$database->setQuery($query);
	$database->query();
	if ($database->getErrorNum()) {
		echo $database->stderr();
	//	return false;
	}
	
	return true;
}

// Return all rows in a particular query.
// Should contain an array of all rows generated by calling mysql_fetch_assoc()
// or equivalent and appending the result of each call to an array.
function bb2_db_rows($result) {
	global $database;
	return $database->loadAssocList();
	
}

// Return emergency contact email address.
function bb2_email() {
global $mosConfig_mailfrom;
	// return "example@example.com";	// You need to change this.
	return $mosConfig_mailfrom;	
}

// retrieve settings from database
// Settings are hard-coded for non-database use
function bb2_read_settings() {
  global $database;
  global $params;
  global $_MAMBOTS;
	if ( !isset($_MAMBOTS->_system_mambot_params['bb2_bot']) ) {
// load mambot params info
		$query = "SELECT id FROM #__mambots WHERE element = 'bb2_bot' AND folder = 'system'";
		$database->setQuery( $query );
	 	$id 	= $database->loadResult();
	 	if ($database->getErrorNum()) {
		echo $database->stderr();
		return false;
	}
	
	 	
	 	$mambot = new mosMambot( $database );
	  	$mambot->load( $id );
	 	$params =& new mosParameters( $mambot->params ); 	

}
else $params =& new mosParameters($_MAMBOTS->_system_mambot_params['bb2_bot'] );

//$params->store();
$params->def('strict', true);
$params->def('verbose', true);
$params->def('log_table', '#__bb2_log');
$params->def('installed', 0);
//print_r($params->_params);
return((Array)($params->_params));

}

// write settings to database
function bb2_write_settings($settings) {
  global $_MAMBOTS;
  global $database;

// load mambot params info
		$query = "SELECT id FROM #__mambots WHERE element = 'bb2_bot' AND folder = 'system'";
		$database->setQuery( $query );
	 	$id 	= $database->loadResult();
	 	if (  ($database->getErrorNum())||(!$id)  ) {
		echo $database->stderr();
		return false;
	}
	
	 	
	 	$mambot = new mosMambot( $database );
	  	$mambot->load( $id );
	 	$params =& new mosParameters( $mambot->params ); 	


  
  //store into bot params database field
  	if (is_array( $settings )) {
$txt = array();
foreach ( $settings as $k=>$v) {
$txt[] = "$k=$v";

}
$mambot->params = implode( "\n", $txt );
$mambot->store();
}
 
  	return true;

}

// installation
function bb2_install() {
  
$settings = bb2_read_settings();
if(!($settings['installed']))
	{
	if (bb2_db_query(bb2_table_structure($settings['log_table'])))
	$settings['installed'] = 1;
	bb2_write_settings($settings);
	echo '<h2>BB2_bot was installed. You only get this message once, at the first run. Enjoy!</h2>
	<p>
	Please refresh this page to clear this message
	</p>
	';
	}
return true;
}

// Screener
// Insert this into the <head> section of your HTML through a template call
// or whatever is appropriate. This is optional we'll fall back to cookies
// if you don't use it.
function bb2_insert_head() {
	global $bb2_javascript;
	global $mainframe;
	//echo $bb2_javascript;
	$mainframe->addCustomHeadTag($bb2_javascript);
}

// Display stats? This is optional.
function bb2_insert_stats($force = false) {
	$settings = bb2_read_settings();

	if ($force || $settings['display_stats']) {
		$blocked = bb2_db_query("SELECT COUNT(*) FROM " . $settings['log_table'] . " WHERE `key` NOT LIKE '00000000'");
		if ($blocked !== FALSE) {
			echo sprintf('<p><a href="http://www.homelandstupidity.us/software/bad-behavior/">%1$s</a> %2$s <strong>%3$s</strong> %4$s</p>', __('Bad Behavior'), __('has blocked'), $blocked[0]["COUNT(*)"], __('access attempts in the last 7 days.'));
		}
	}
}

// Return the top-level relative path of wherever we are (for cookies)
// You should provide in $url the top-level URL for your site.
function bb2_relative_path() {
	global $mosConfig_live_site;
	//$url = parse_url(get_bloginfo('url'));
	//return $url['path'] . '/';
	return $mosConfig_live_site.'/';
}

// Calls inward to Bad Behavor itself.
require_once(BB2_CWD . "/version.inc.php");
require_once(BB2_CWD . "/core.inc.php");
bb2_install();	// FIXME: see above


	//require_once(BB2_CWD . "/admin.inc.php");

bb2_start(bb2_read_settings());

?>
